#include <vector>
#include <queue>
#include <algorithm>

#include "defines.hh"

#include "prologin.hh"
#include "analyzer.hh"

using namespace std;

class AI {
private:
    queue<position> buildQueue;
    queue<position> targets;
    Analyzer *analyzer ;
    short stage = 0;

    position target;
    short targetType;
    bool targetReached = true;
    bool allTargetsReached = false;

    bool destroyLoop = false;
    position destroyedPosition;

public:
    AI() {
        analyzer = new Analyzer();
    }

    void aimForKeyPosition();

    void rebuildQueue();

    void continueBuilding(int count);

    void optimizeSucking();

    void repare();

    position getNextTarget();

    void addTarget(position pos);

};
